PCHAR  DATA = NULL;
DWORD gr_icon_cnt; char res_name[MAX_PATH];
DWORD res_name_num;

BOOL rt_gr_icon_func(

    HANDLE hModule,	// resource-module handle 
    LPCTSTR lpszType,	// pointer to resource type 
    LPTSTR lpszName,	// pointer to resource name 
    LONG lParam 	// application-defined parameter  
   )
{
	if (gr_icon_cnt == 0)
	{
		if ((DWORD)lpszName < 0x0000FFFF)
			res_name_num = (DWORD)lpszName;
		else
			strcpy(res_name, lpszName);
		gr_icon_cnt++;
		return TRUE;
	}
	gr_icon_cnt++;
	return FALSE;
}

//resource icon struct (exe file resources)
//RT_GROUP_ICON
#pragma pack( push )
#pragma pack( 2 )
typedef struct
{
   BYTE   bWidth;               // Width, in pixels, of the image
   BYTE   bHeight;              // Height, in pixels, of the image
   BYTE   bColorCount;          // Number of colors in image (0 if >=8bpp)
   BYTE   bReserved;            // Reserved
   WORD   wPlanes;              // Color Planes
   WORD   wBitCount;            // Bits per pixel
   DWORD  dwBytesInRes;         // how many bytes in this resource?
   WORD   nID;                  // the ID
} GRPICONDIRENTRY, *LPGRPICONDIRENTRY;
#pragma pack( pop )

#pragma pack( push )
#pragma pack( 2 )
typedef struct 
{
   WORD                 wReserved;   // Reserved (must be 0)
   WORD                 wType;       // Resource type (1 for icons)
   WORD                 wIconDirCount;      // How many images?
   GRPICONDIRENTRY      IconDirEntries[1]; // The entries for each image
} GRPICONDIR, *LPGRPICONDIR;
#pragma pack( pop )

//RT_ICON
typedef struct
{
   BITMAPINFOHEADER         icHeader;      // DIB header
   RGBQUAD                  icColors[1];   // Color table
   BYTE                     icXOR[1];      // DIB bits for XOR mask
   BYTE                     icAND[1];      // DIB bits for AND mask
} ICONIMAGE, *LPICONIMAGE;
////////////////////////////////////////////////////////////
//.ico file struct
typedef struct
{
    BYTE        bWidth;          // Width, in pixels, of the image
    BYTE        bHeight;         // Height, in pixels, of the image
    BYTE        bColorCount;     // Number of colors in image (0 if >=8bpp)
    BYTE        bReserved;       // Reserved ( must be 0)
    WORD        wPlanes;         // Color Planes
    WORD        wBitCount;       // Bits per pixel
    DWORD       dwBytesInRes;    // How many bytes in this resource?
    DWORD       dwImageOffset;   // Where in the file is this image?
} ICONDIRENTRY, *LPICONDIRENTRY;

//error codes for IconResource class
#define ERR_CANNOT_OPEN_FILE        9000L
#define ERR_ALLOCATING_MEMORY       9001L
#define ERR_CANNOT_READ_FILE        9002L
#define ERR_CANNOT_SEEK_TO_IMAGE    9003L

///////////////////////////////////////////////////////////////////////////////////////////////
// (c) SimBiOd, 2005 //////////////////////////////////////////////////////////////////////////
/// URL:  http://forum.sources.ru/index.php?showtopic=92327 ///////////////////////////////////
BOOL ReplaceIcon(PCHAR FileSRC, PCHAR FileDEST, INT ICON_GROUP)
{
	//try {

	//      2-  
	HGLOBAL hResLoad;
	HMODULE hModule;
	HRSRC hRes;
	//HANDLE hUpdateRes; 
	LPVOID lpResLock; 
	//BOOL result;
	LPGRPICONDIR gid;
	INT i;
	
	//        
	//hModule = LoadLibrary(FileSRC);
	hModule = LoadLibraryEx(FileSRC, 0, LOAD_LIBRARY_AS_DATAFILE);
	//    ,  
	if(hModule == NULL) return FALSE;

	if (ICON_GROUP < 0)
	{
		//   ICON_GROUP (..    EXE-)
		gr_icon_cnt = 0; res_name[0] = '\0'; res_name_num = 0xFFFFFF; hRes = NULL;
		EnumResourceNames(hModule, RT_GROUP_ICON, (ENUMRESNAMEPROC)rt_gr_icon_func, NULL);
		if (res_name[0] != '\0')
			hRes = FindResource(hModule, res_name, RT_GROUP_ICON);
		else if (res_name_num != 0xFFFFFF)
			hRes = FindResource(hModule, (LPCSTR)res_name_num, RT_GROUP_ICON);
	}
	else
		//   ICON_GROUP
		hRes = FindResource(hModule, (LPCSTR)ICON_GROUP, RT_GROUP_ICON);
	
	if(hRes == NULL){ FreeLibrary(hModule);	return FALSE;}
	//   ICON_GROUP
	hResLoad = LoadResource(hModule, hRes); 
	if(hResLoad == NULL){ FreeLibrary(hModule); return FALSE;}
	//   ICON_GROUP
	gid = (LPGRPICONDIR)LockResource(hResLoad); 
	if(gid == NULL){ FreeLibrary(hModule); return FALSE;}
	
	//      ,     EXE
	for (i = 0, hRes = NULL; i < gid->wIconDirCount; i++)
	{
		hRes = FindResource(hModule, MAKEINTRESOURCE(gid->IconDirEntries[i].nID), RT_ICON);
		if(hRes == NULL){ FreeLibrary(hModule); return FALSE;}
		if (gid->IconDirEntries[i].dwBytesInRes == XP_ICON)
			break;
	}

	//     ,   ,     
	//   
	INT i_bck = i, MAX_SIZE = 0;
	if (i == gid->wIconDirCount)
	{
		i_bck = -1;
		for (i = 0, hRes = NULL; i < gid->wIconDirCount; i++)
		{
			hRes = FindResource(hModule, MAKEINTRESOURCE(gid->IconDirEntries[i].nID), RT_ICON);
			if(hRes == NULL){ FreeLibrary(hModule); return FALSE;}
			if (gid->IconDirEntries[i].dwBytesInRes < XP_ICON)
			{
				if (MAX_SIZE < (INT)gid->IconDirEntries[i].dwBytesInRes)
				{
					MAX_SIZE = gid->IconDirEntries[i].dwBytesInRes;
					i_bck = i;
				}
				//break;
			}
		}
	}

	if ((i_bck == -1) || (gid->wIconDirCount == 0)){ FreeLibrary(hModule); return FALSE;}

	i = i_bck;

	//  
	hResLoad = LoadResource(hModule, hRes); 
	//     ,  
	if(hResLoad == NULL)
	{
		//   
		FreeLibrary(hModule);
		return FALSE;
	}
	
	//  
	lpResLock = LockResource(hResLoad); 
	//     ,  
	if(lpResLock == NULL)
	{
		//   
		FreeLibrary(hModule);
		return FALSE;
	}

	//      
	HANDLE hUpdateRes = BeginUpdateResource(FileDEST, TRUE);
	//     ,  
	if (hUpdateRes == NULL)
	{
		//   
		FreeLibrary(hModule);
		return FALSE;
	}
	
	//       
	BOOL result = UpdateResource(hUpdateRes,RT_ICON,MAKEINTRESOURCE(1),
		MAKELANGID(LANG_ENGLISH, SUBLANG_DEFAULT),lpResLock,SizeofResource(hModule, hRes)); 
	//     ,  
	if (result == FALSE)
	{
		//   
		FreeLibrary(hModule);
		return FALSE;
	}

	

	// ** RT_GROUP_ICON
  // **    
  GRPICONDIR groupIcon;

  groupIcon.wReserved    = gid->wReserved;
  groupIcon.wType      = gid->wType;
  groupIcon.wIconDirCount  = 1;

    groupIcon.IconDirEntries[0].wBitCount    = gid->IconDirEntries[i].wBitCount;
    groupIcon.IconDirEntries[0].bColorCount  = gid->IconDirEntries[i].bColorCount;
    groupIcon.IconDirEntries[0].bHeight      = gid->IconDirEntries[i].bHeight;
    groupIcon.IconDirEntries[0].bWidth       = gid->IconDirEntries[i].bWidth;
    groupIcon.IconDirEntries[0].dwBytesInRes = gid->IconDirEntries[i].dwBytesInRes;
    groupIcon.IconDirEntries[0].wPlanes      = gid->IconDirEntries[i].wPlanes;
    groupIcon.IconDirEntries[0].bReserved    = gid->IconDirEntries[i].bReserved;
    groupIcon.IconDirEntries[0].nID          = 1;

	result = UpdateResource( hUpdateRes, RT_GROUP_ICON, MAKEINTRESOURCE(IDI_ICON), MAKELANGID(LANG_ENGLISH, SUBLANG_DEFAULT),
               &groupIcon, sizeof(GRPICONDIR) );


	
	//  
	if(EndUpdateResource(hUpdateRes, FALSE) != NULL){
	
	//    
	if(FreeLibrary(hModule) == NULL) return FALSE;
	return TRUE;

	}// catch(...) { return FALSE;}

	return FALSE;
}
